JSDOC.PluginManager.registerPlugin(
	"aias.easyLink",
	{
		onDocTag: function(tag) {

			//exclude @example
			if (tag.title=="example") return;
			if (!tag.desc) return;

			//turn double-blanketted string into link -- <a> HTML tag or @link doctag.
			tag.desc = tag.desc.replace(aias.easyLink.reFindLink, aias.easyLink.replaceToLink);

			//turn URL into <a> tag.
			tag.desc = tag.desc.replace(aias.easyLink.reFindURL, "<a href=\"$1\">$1</a>");

			//turn mail address into <a> tag.
			tag.desc = tag.desc.replace(aias.easyLink.reFindMail, "<a href=\"mailto:$1\">$1</a>");
		}
	}
);

Namespace("aias.easyLink");

aias.easyLink.replaceToLink = function(match, str1, delim, str2) {
	var text = "";
	var url = "";
	var blank = "";

	if (delim) {
		if (!str2) return match;

		url = str2;
		text = str1 || str2;
		if (delim===">>") blank = " target=\"_blank\"";
	}
	else {
		text = url = str1;
	}

//	LOG.warn(whole);
//	LOG.warn(text+","+url+","+blank);

	if (aias.easyLink.reIsURL.test(url)) { //URL?
		return "<a href=\""+url+"\""+blank+" >"+text+"</a>";
	}
	if (aias.easyLink.reIsMail.test(url)) { //mail address?
		return "<a href=\"mailto:"+url+"\" >"+text+"</a>";
	}
	if (aias.easyLink.reIsNamePath.test(url)) { //namepath?
		return "{@link "+url+" }";
	}

	return match;

};

aias.easyLink.reFindLink = /\[\[([^\]>]*)(>>?)?(.*?)]]/g;
aias.easyLink.reFindURL = /[\s^]((?:https?|ftp):\/\/[0-9a-zA-Z,;:~&=@_'%?+\-\/$.!*()]+)[\s$]/g;
aias.easyLink.reFindMail = /[\s^]([a-z0-9\-_.]+@[a-z0-9\-_]+(?:\.[a-z0-9\-_]+)+)[\s$]/gi;

aias.easyLink.reIsURL = /[a-zA-Z]+:\/\/[0-9a-zA-Z,;:~&=@_'%?+\-\/$.!*()]+/;
aias.easyLink.reIsMail = /[a-z0-9\-_.]+@[a-z0-9\-_]+(?:\.[a-z0-9\-_]+)+/i;
aias.easyLink.reIsNamePath = /[a-zA-Z0-9_]+([#.-][a-zA-Z0-9_]+)*/;
